namespace BP
{
	namespace Inventory
	{
		//------------------------------------------------------------------------------------------------------------------------
		void Give(int itemID, int amount, kPlayer player = LocalPlayer)
		{
			for (int i = 0; i < amount; i++)
			{
				player.Inventory().Give(itemID);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Take(int itemID, int amount, kPlayer player = LocalPlayer)
		{
			for (int i = 0; i < amount; i++)
			{
				player.Inventory().Take(itemID);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Has(int itemID, int amount = 1, kPlayer player = LocalPlayer)
		{
			return GetCount(itemID, player) >= amount;
		}
		//------------------------------------------------------------------------------------------------------------------------
		int GetCount(int itemID, kPlayer player = LocalPlayer)
		{
			return player.Inventory().GetCount(itemID);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Clear(kPlayer player = LocalPlayer)
		{
			player.Inventory().Reset();
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
