namespace BP
{
	kActor @map;
	namespace Map
	{
		//------------------------------------------------------------------------------------------------------------------------
		kActor@ Actor()
		{
			OnCreate();
			return @map;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnCreate()
		{
			//load and spawn a map controller actor if map def has one else spawn a default map controller
			if (map is null)
			{
				//check if a map is already in the lvel
				// if (Network.IsNetgame())
				// {
					// @map = FindMPMapActor();
					// if (map is null)
					// {
						// @map = BP::Spawn::Actor(BP_Actor_CoopMap, Math::vecZero);
					// }
				// }
				// else
				// {
					@map = FindMapActor();
					if (map is null)
					{
						@map = BP::Spawn::Actor(BP_Actor_Map, Math::vecZero);
					}
				// }
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Finds the first map in the level and returns the actor or null if no actor
		//------------------------------------------------------------------------------------------------------------------------
		kActor@ FindMapActor()
		{
			FOREACH_ACTOR
			{
				if (actor.Type() >= BP_Actor_Map && actor.Type() <= BP_MaxMapType)
				{
					return @actor;
				}
			}
			return null;
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Finds the first map in the level and returns the actor or null if no actor
		//------------------------------------------------------------------------------------------------------------------------
		kActor@ FindMPMapActor()
		{
			FOREACH_ACTOR
			{
				if (actor.Type() >= BP_Actor_CoopMap && actor.Type() <= BP_MaxCoopMapType)
				{
					return @actor;
				}
			}
			return null;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnDestroy()
		{
			@map = null;
		}
		//------------------------------------------------------------------------------------------------------------------------
		float Time()
		{
			return BP::Map::Actor().Health();
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
