namespace BP
{
	namespace String
	{
		const array<kStr> asciiChars = {
			"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
			"", "", ' ', '!', '"', "", "", '%', '&', '\'', '(', ')', '*', '+', ',', '-', ".", "/", '0', '1', '2', '3', '4', '5', '6',
			'7', '8', '9', ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N',
			'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f',
			'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ""
		};
		//------------------------------------------------------------------------------------------------------------------------
		int Length(kStr &in s)
		{
			kStr key = "[<-L->]";
			s += key;
			return s.IndexOf(key);
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Equals(kStr &in s, kStr &in s2)
		{
			return s.Hash() == s2.Hash();
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool IsEmpty(kStr &in s)
		{
			return s.Hash() == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		kStr Index(kStr &in s, int index)
		{
			int8 c = s[index];
			DebugAssert(c >= 0 && c <= 127, "[BP::String::Index] char " + c + " is not a value of 0..127"); //range could be -128..127
			return asciiChars[s[index]];
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
